// complex_class.cpp
// Ex. 6.6: complex numbers using friend
//
#include <stdio.h>

class Complex {
private:
  float real, imag;
public:
  Complex( float = 0.0, float = 0.0);
  friend Complex add( Complex, Complex);
  friend void print(Complex);
};

Complex::Complex( float r, float i)
{ real = r; imag = i; }

Complex add( Complex a, Complex b )
{ Complex c;
  c.real = a.real + b.real;
  c.imag = a.imag + b.imag;
  return c;
}

void print(Complex c)
{ printf("( %f, %f )",c.real,c.imag);
}

main()
{ Complex a(1.0,1.0), b(-1.0,1.0), c;
  c = add(a,b); 
  print(a); printf(" + "); print(b); printf(" = ");
  print(c); printf("\n");
  return 0;
}

